> This page is for API, version 2026-01-01 (Stable) (default).
> For other versions, use one of these documentation indexes:
> - 2026-01-01 (Stable) (default): https://developer.deel.com/api/stable/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.deel.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.deel.com/_mcp/server.

# List of immigration cases

GET https://api.letsdeel.com/rest/immigration/client/cases

Use this endpoint to track the progress of your organization's immigration cases and identify ones that need attention, such as those currently on hold.

 **Token scopes**: `immigration:read`

Reference: https://developer.deel.com/api/endpoints/immigration/get-client-cases

## Authentication

- `Authorization` header (bearer token, required) — ## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
- `Authorization` header (bearer token, required) — Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

## Servers

- `https://api.letsdeel.com/rest` (Production, default)
- `https://api-staging.letsdeel.com/rest` (Demo)

## Request

### Query parameters

- `search` (string, optional) — Search by applicant name or code
- `case_type_ids` (list of string, optional) — Filter by case type IDs
- `statuses` (list of enum, optional) — Filter by case status
  - Allowed values: `OPEN`, `ON_HOLD`, `CLOSED`
- `countries` (list of string, optional) — Filter by country. Uses ISO 3166-1 alpha-2 codes (https://www.iban.com/country-codes).
- `cursor` (string, optional) — Pagination cursor for fetching next set of results
- `limit` (integer, optional, default: 20) — Max number of results to return

## Response

### 200

Successful operation.

- `data` (list of ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItems, required) — List of cases in the current page.
- `has_more` (boolean, required) — Indicates whether more results are available for pagination.
- `total_count` (integer, required) — Total number of cases matching the search criteria.
- `next_cursor` (string, optional, nullable) — Cursor value to be used for fetching the next page of results.

## Errors

### 400 Bad Request Error

Operation failed.

- `errors` (list of ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 401 Unauthorized Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 403 Forbidden Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 404 Not Found Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 500 Internal Server Error

Operation failed.

- `errors` (list of ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaErrorsItems, optional)

## Types

### ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItems

- `id` (string, required) — Unique identifier of the immigration case.
- `status` (enum, required) — Current lifecycle status of the immigration case.
  - Allowed values: `OPEN`, `CLOSED`, `ON_HOLD`
- `closure` (ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsClosure, required, nullable) — Closure details of the case if the case has been closed.
- `process` (ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsProcess, required) — Current active process associated with the case.
- `applicant` (ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsApplicant, required, nullable) — Applicant associated with the immigration case.
- `case_type` (ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsCaseType, required) — Type of immigration case.
- `created_at` (string, required) — Timestamp indicating when the case was created.
- `updated_at` (string, required) — Timestamp indicating when the case was last updated.

### ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaErrorsItems

- `code` (string, optional) — Machine-readable error code
- `message` (string, optional) — Human-readable explanation of the error

### ApiErrorRequest

- `method` (string, optional) — The HTTP method of the failed request
- `url` (string, optional) — The relative URL of the failed request
- `status` (double, optional) — The status code of the response
- `api_req_id` (string, optional) — The request ID of the failed request
- `docs` (string, optional) — A link to the official documentation for the requested endpoint resource
- `source` (string, optional) — The source handler which produced the returned error
- `code` (double, optional) — The code of the source handler which produced the returned error

### ApiError

- `message` (string, optional) — A description of the returned error
- `path` (string, optional) — The JSON path where input validation failed

### ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsClosure

Closure details of the case if the case has been closed.

- `note` (string, required, nullable) — Additional notes explaining the case closure.
- `reason` (enum, required, nullable) — Reason why the immigration case was closed.
  - Allowed values: `CONTRACT_CANCELLED`, `NATIONALITY_CHANGE`, `NEW_CASE_TYPE_IS_REQUIRED`, `ONBOARDING_RELEASED`, `TERMINATION_REVERSED`, `CONVERTED_TO_VISA_APPLICATION`, `OTHER`

### ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsProcess

Current active process associated with the case.

- `id` (string, required) — Unique identifier of the current process.
- `name` (string, required) — Human-readable name of the current process step.
- `status` (ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsProcessStatus, required) — Current status of the process.

### ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsApplicant

Applicant associated with the immigration case.

- `name` (string, required) — Full name of the applicant.
- `id` (string, optional, nullable) — Unique identifier of the applicant.

### ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsCaseType

Type of immigration case.

- `id` (string, required) — Unique identifier of the case type.
- `name` (string, required) — Human-readable name of the case type.

### ImmigrationClientCasesGetResponsesContentApplicationJsonSchemaDataItemsProcessStatus

Current status of the process.

- `id` (string, required, nullable) — Unique identifier of the process status.
- `name` (string, required, nullable) — Human-readable name of the process status.

## Examples

**Response**

```json
{
  "data": [
    {
      "id": "d7348f5b-b0a6-4c84-ae07-2e5ccdd60134",
      "status": "OPEN",
      "closure": {
        "note": "Employee contract was terminated.",
        "reason": "CONTRACT_CANCELLED"
      },
      "process": {
        "id": "c8895566-11aa-22bb-33cc-44dd55ee66ff",
        "name": "Initial Review",
        "status": {
          "id": "f1234567-abcd-ef01-2345-6789abcd0123",
          "name": "IN_PROGRESS"
        }
      },
      "applicant": {
        "name": "John Doe",
        "id": "b1234567-89ab-cdef-0123-456789abcdef"
      },
      "case_type": {
        "id": "a1234567-89ab-cdef-0123-456789abcdef",
        "name": "Work Permit"
      },
      "created_at": "2024-01-12T08:30:00Z",
      "updated_at": "2024-01-13T10:45:00Z"
    }
  ],
  "has_more": true,
  "total_count": 100,
  "next_cursor": "eyJpZCI6IjEyMzQ1NiJ9"
}
```

**SDK Code**

```python
import requests

url = "https://api.letsdeel.com/rest/immigration/client/cases"

querystring = {"case_type_ids":"[\"e9b4ce94-2e3e-4d41-9faf-1ad2389cac1d\"]","countries":"[\"AE\",\"SA\"]","cursor":"next-page-token-123","limit":"20","search":"john","statuses":"[\"OPEN\",\"ON_HOLD\",\"CLOSED\"]"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/immigration/client/cases?case_type_ids=%5B%22e9b4ce94-2e3e-4d41-9faf-1ad2389cac1d%22%5D&countries=%5B%22AE%22%2C%22SA%22%5D&cursor=next-page-token-123&limit=20&search=john&statuses=%5B%22OPEN%22%2C%22ON_HOLD%22%2C%22CLOSED%22%5D';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/immigration/client/cases?case_type_ids=%5B%22e9b4ce94-2e3e-4d41-9faf-1ad2389cac1d%22%5D&countries=%5B%22AE%22%2C%22SA%22%5D&cursor=next-page-token-123&limit=20&search=john&statuses=%5B%22OPEN%22%2C%22ON_HOLD%22%2C%22CLOSED%22%5D"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/immigration/client/cases?case_type_ids=%5B%22e9b4ce94-2e3e-4d41-9faf-1ad2389cac1d%22%5D&countries=%5B%22AE%22%2C%22SA%22%5D&cursor=next-page-token-123&limit=20&search=john&statuses=%5B%22OPEN%22%2C%22ON_HOLD%22%2C%22CLOSED%22%5D")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/immigration/client/cases?case_type_ids=%5B%22e9b4ce94-2e3e-4d41-9faf-1ad2389cac1d%22%5D&countries=%5B%22AE%22%2C%22SA%22%5D&cursor=next-page-token-123&limit=20&search=john&statuses=%5B%22OPEN%22%2C%22ON_HOLD%22%2C%22CLOSED%22%5D")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/immigration/client/cases?case_type_ids=%5B%22e9b4ce94-2e3e-4d41-9faf-1ad2389cac1d%22%5D&countries=%5B%22AE%22%2C%22SA%22%5D&cursor=next-page-token-123&limit=20&search=john&statuses=%5B%22OPEN%22%2C%22ON_HOLD%22%2C%22CLOSED%22%5D', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/immigration/client/cases?case_type_ids=%5B%22e9b4ce94-2e3e-4d41-9faf-1ad2389cac1d%22%5D&countries=%5B%22AE%22%2C%22SA%22%5D&cursor=next-page-token-123&limit=20&search=john&statuses=%5B%22OPEN%22%2C%22ON_HOLD%22%2C%22CLOSED%22%5D");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/immigration/client/cases?case_type_ids=%5B%22e9b4ce94-2e3e-4d41-9faf-1ad2389cac1d%22%5D&countries=%5B%22AE%22%2C%22SA%22%5D&cursor=next-page-token-123&limit=20&search=john&statuses=%5B%22OPEN%22%2C%22ON_HOLD%22%2C%22CLOSED%22%5D")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```